blob: 03e163ef0aecaa9af9ab0812e85a781187dfdb13 [file] [log] [blame]
Simon Glassbbb0b122011-10-15 05:48:21 +00001#
2# Copyright (c) 2011 The Chromium OS Authors.
3#
4# See file CREDITS for list of people who contributed to this
5# project.
6#
7# This program is free software; you can redistribute it and/or
8# modify it under the terms of the GNU General Public License as
9# published by the Free Software Foundatio; either version 2 of
10# the License, or (at your option) any later version.
11#
12# This program is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15# GNU General Public License for more details.
16#
17# You should have received a copy of the GNU General Public License
18# along with this program; if not, write to the Free Software
19# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
20# MA 02111-1307 USA
21#
22
23# This Makefile builds the internal U-Boot fdt if CONFIG_OF_CONTROL is
24# enabled. See doc/README.fdt-control for more details.
25
26include $(TOPDIR)/config.mk
27
28LIB = $(obj)libdts.o
29
Jagannadha Sutradharudu Teki74de8c92013-02-28 10:20:18 +000030ifeq ($(DEVICE_TREE),)
Simon Glassbbb0b122011-10-15 05:48:21 +000031$(if $(CONFIG_DEFAULT_DEVICE_TREE),,\
32$(error Please define CONFIG_DEFAULT_DEVICE_TREE in your board header file))
33DEVICE_TREE = $(subst ",,$(CONFIG_DEFAULT_DEVICE_TREE))
Jagannadha Sutradharudu Teki74de8c92013-02-28 10:20:18 +000034endif
Simon Glassbbb0b122011-10-15 05:48:21 +000035
36$(if $(CONFIG_ARCH_DEVICE_TREE),,\
37$(error Your architecture does not have device tree support enabled. \
38Please define CONFIG_ARCH_DEVICE_TREE))
39
40# We preprocess the device tree file provide a useful define
Allen Martin6487d882013-01-08 16:07:54 +000041DTS_CPPFLAGS := -x assembler-with-cpp \
Horst Kronstorferb4f106b2012-07-13 03:03:40 +000042 -DARCH_CPU_DTS=\"$(SRCTREE)/arch/$(ARCH)/dts/$(CONFIG_ARCH_DEVICE_TREE).dtsi\" \
Tom Warren6c5be642013-02-21 12:31:27 +000043 -DBOARD_DTS=\"$(SRCTREE)/board/$(VENDOR)/$(BOARD)/dts/$(DEVICE_TREE).dts\" \
44 -I$(SRCTREE)/board/$(VENDOR)/dts -I$(SRCTREE)/arch/$(ARCH)/dts
Simon Glassbbb0b122011-10-15 05:48:21 +000045
46all: $(obj).depend $(LIB)
47
48# Use a constant name for this so we can access it from C code.
49# objcopy doesn't seem to allow us to set the symbol name independently of
50# the filename.
51DT_BIN := $(obj)dt.dtb
52
53$(DT_BIN): $(TOPDIR)/board/$(VENDOR)/dts/$(DEVICE_TREE).dts
Wolfgang Denk896bbb52012-04-19 02:36:44 +000054 rc=$$( \
55 cat $< | $(CPP) -P $(DTS_CPPFLAGS) - | \
56 { { $(DTC) -R 4 -p 0x1000 -O dtb -o ${DT_BIN} - 2>&1 ; \
57 echo $$? >&3 ; } | \
58 grep -v '^DTC: dts->dtb on file' ; \
Stephen Warren58e22f82012-06-08 12:28:17 +000059 } 3>&1 1>&2 ) ; \
Wolfgang Denk896bbb52012-04-19 02:36:44 +000060 exit $$rc
Simon Glassbbb0b122011-10-15 05:48:21 +000061
62process_lds = \
63 $(1) | sed -r -n 's/^OUTPUT_$(2)[ ("]*([^")]*).*/\1/p'
64
65# Run the compiler and get the link script from the linker
66GET_LDS = $(CC) $(CFLAGS) $(LDFLAGS) -Wl,--verbose 2>&1
67
68$(obj)dt.o: $(DT_BIN)
69 # We want the output format and arch.
70 # We also hope to win a prize for ugliest Makefile / shell interaction
71 # We look in the LDSCRIPT first.
72 # Then try the linker which should give us the answer.
73 # Then check it worked.
Horst Kronstorfera4ff4712012-07-12 02:58:32 +000074 [ -n "$(LDSCRIPT)" ] && \
75 oformat=`$(call process_lds,cat $(LDSCRIPT),FORMAT)` && \
76 oarch=`$(call process_lds,cat $(LDSCRIPT),ARCH)` ;\
Simon Glassbbb0b122011-10-15 05:48:21 +000077 \
78 [ -z $${oformat} ] && \
79 oformat=`$(call process_lds,$(GET_LDS),FORMAT)` ;\
80 [ -z $${oarch} ] && \
81 oarch=`$(call process_lds,$(GET_LDS),ARCH)` ;\
82 \
83 [ -z $${oformat} ] && \
84 echo "Cannot read OUTPUT_FORMAT from lds file $(LDSCRIPT)" && \
85 exit 1 || true ;\
86 [ -z $${oarch} ] && \
87 echo "Cannot read OUTPUT_ARCH from lds file $(LDSCRIPT)" && \
88 exit 1 || true ;\
89 \
90 cd $(dir ${DT_BIN}) && \
91 $(OBJCOPY) -I binary -O $${oformat} -B $${oarch} \
92 $(notdir ${DT_BIN}) $@
93 rm $(DT_BIN)
94
95OBJS-$(CONFIG_OF_EMBED) := dt.o
96
97COBJS := $(OBJS-y)
98
99OBJS := $(addprefix $(obj),$(COBJS))
100
101binary: $(DT_BIN)
102
103$(LIB): $(OBJS) $(DTB)
104 $(call cmd_link_o_target, $(OBJS))
105
106#########################################################################
107
108# defines $(obj).depend target
109include $(SRCTREE)/rules.mk
110
111sinclude $(obj).depend
112
113#########################################################################